diff --git a/src/nsdbc/nsdb-annotate.c b/src/nsdbc/nsdb-annotate.c
index d35c7a491ec2..19fc8eb4b1ee 100644
--- a/src/nsdbc/nsdb-annotate.c
+++ b/src/nsdbc/nsdb-annotate.c
@@ -167,7 +167,6 @@ main(int argc, char **argv)
 			break;
 		case '?':
 			nsdb_annotate_usage(progname);
-			break;
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
diff --git a/src/nsdbc/nsdb-create-fsl.c b/src/nsdbc/nsdb-create-fsl.c
index ef79cc731feb..0ffd2e6614d1 100644
--- a/src/nsdbc/nsdb-create-fsl.c
+++ b/src/nsdbc/nsdb-create-fsl.c
@@ -162,10 +162,11 @@ main(int argc, char **argv)
 				nsdb_create_fsl_usage(progname);
 			}
 			break;
+		case '?':
+			nsdb_create_fsl_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_create_fsl_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-create-fsn.c b/src/nsdbc/nsdb-create-fsn.c
index d6c39ea94124..d4bcd6eb6f72 100644
--- a/src/nsdbc/nsdb-create-fsn.c
+++ b/src/nsdbc/nsdb-create-fsn.c
@@ -170,10 +170,11 @@ main(int argc, char **argv)
 			}
 			ttl = (unsigned int)tmp;
 			break;
+		case '?':
+			nsdb_create_fsn_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_create_fsn_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-delete-fsl.c b/src/nsdbc/nsdb-delete-fsl.c
index f64a8fde5316..eb6b4026e451 100644
--- a/src/nsdbc/nsdb-delete-fsl.c
+++ b/src/nsdbc/nsdb-delete-fsl.c
@@ -152,10 +152,11 @@ main(int argc, char **argv)
 				nsdb_delete_fsl_usage(progname);
 			}
 			break;
+		case '?':
+			nsdb_delete_fsl_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_delete_fsl_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-delete-fsn.c b/src/nsdbc/nsdb-delete-fsn.c
index 3060c247e2d8..d76bfad1c3d8 100644
--- a/src/nsdbc/nsdb-delete-fsn.c
+++ b/src/nsdbc/nsdb-delete-fsn.c
@@ -154,10 +154,11 @@ main(int argc, char **argv)
 		case 'y':
 			leave_fsn = true;
 			break;
+		case '?':
+			nsdb_delete_fsn_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_delete_fsn_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-delete-nsdb.c b/src/nsdbc/nsdb-delete-nsdb.c
index 2e793bf00b96..e49c5d59446b 100644
--- a/src/nsdbc/nsdb-delete-nsdb.c
+++ b/src/nsdbc/nsdb-delete-nsdb.c
@@ -138,10 +138,11 @@ main(int argc, char **argv)
 				nsdb_delete_nsdb_usage(progname);
 			}
 			break;
+		case '?':
+			nsdb_delete_nsdb_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_delete_nsdb_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-describe.c b/src/nsdbc/nsdb-describe.c
index ec060be5bf5b..59ce45d3ca92 100644
--- a/src/nsdbc/nsdb-describe.c
+++ b/src/nsdbc/nsdb-describe.c
@@ -154,10 +154,11 @@ main(int argc, char **argv)
 		case 'y':
 			delete = true;
 			break;
+		case '?':
+			nsdb_describe_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_describe_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-list.c b/src/nsdbc/nsdb-list.c
index e6de357a539d..3f9288b35430 100644
--- a/src/nsdbc/nsdb-list.c
+++ b/src/nsdbc/nsdb-list.c
@@ -329,10 +329,11 @@ main(int argc, char **argv)
 				nsdb_list_usage(progname);
 			}
 			break;
+		case '?':
+			nsdb_list_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_list_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-nces.c b/src/nsdbc/nsdb-nces.c
index c67fd18936b0..b4f74fc4e64c 100644
--- a/src/nsdbc/nsdb-nces.c
+++ b/src/nsdbc/nsdb-nces.c
@@ -135,10 +135,11 @@ main(int argc, char **argv)
 				nsdb_nces_usage(progname);
 			}
 			break;
+		case '?':
+			nsdb_nces_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_nces_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-remove-nci.c b/src/nsdbc/nsdb-remove-nci.c
index f6b58c9d0ab8..abcad47c5c9b 100644
--- a/src/nsdbc/nsdb-remove-nci.c
+++ b/src/nsdbc/nsdb-remove-nci.c
@@ -143,10 +143,11 @@ main(int argc, char **argv)
 				nsdb_remove_nci_usage(progname);
 			}
 			break;
+		case '?':
+			nsdb_remove_nci_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_remove_nci_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-resolve-fsn.c b/src/nsdbc/nsdb-resolve-fsn.c
index 1230e6d76aef..100f7aa97edd 100644
--- a/src/nsdbc/nsdb-resolve-fsn.c
+++ b/src/nsdbc/nsdb-resolve-fsn.c
@@ -293,10 +293,11 @@ main(int argc, char **argv)
 				nsdb_resolve_fsn_usage(progname);
 			}
 			break;
+		case '?':
+			nsdb_resolve_fsn_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_resolve_fsn_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-simple-nce.c b/src/nsdbc/nsdb-simple-nce.c
index 75c0386fcc2e..c99952ce85fe 100644
--- a/src/nsdbc/nsdb-simple-nce.c
+++ b/src/nsdbc/nsdb-simple-nce.c
@@ -138,10 +138,11 @@ main(int argc, char **argv)
 				nsdb_simple_nce_usage(progname);
 			}
 			break;
+		case '?':
+			nsdb_simple_nce_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_simple_nce_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-update-fsl.c b/src/nsdbc/nsdb-update-fsl.c
index f5a4cb9249fd..23330ca380a5 100644
--- a/src/nsdbc/nsdb-update-fsl.c
+++ b/src/nsdbc/nsdb-update-fsl.c
@@ -158,10 +158,11 @@ main(int argc, char **argv)
 		case 'v':
 			value = optarg;
 			break;
+		case '?':
+			nsdb_update_fsl_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_update_fsl_usage(progname);
 		}
 	}
diff --git a/src/nsdbc/nsdb-update-nci.c b/src/nsdbc/nsdb-update-nci.c
index 2da0aa13cc69..fa10d847a09f 100644
--- a/src/nsdbc/nsdb-update-nci.c
+++ b/src/nsdbc/nsdb-update-nci.c
@@ -151,10 +151,11 @@ main(int argc, char **argv)
 		case 'y':
 			delete = true;
 			break;
+		case '?':
+			nsdb_update_nci_usage(progname);
 		default:
 			fprintf(stderr, "Invalid command line "
 				"argument: %c\n", (char)arg);
-		case '?':
 			nsdb_update_nci_usage(progname);
 		}
 	}