diff --git a/src/fedfsc/fedfs-create-junction.c b/src/fedfsc/fedfs-create-junction.c
index 987c02a..bbd1598 100644
--- a/src/fedfsc/fedfs-create-junction.c
+++ b/src/fedfsc/fedfs-create-junction.c
@@ -173,7 +173,7 @@ fedfs_create_junction_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-create-replication.c b/src/fedfsc/fedfs-create-replication.c
index 4effb2c..a9b2ec1 100644
--- a/src/fedfsc/fedfs-create-replication.c
+++ b/src/fedfsc/fedfs-create-replication.c
@@ -173,7 +173,7 @@ fedfs_create_replication_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-delete-junction.c b/src/fedfsc/fedfs-delete-junction.c
index 97bd072..6e0211d 100644
--- a/src/fedfsc/fedfs-delete-junction.c
+++ b/src/fedfsc/fedfs-delete-junction.c
@@ -163,7 +163,7 @@ fedfs_delete_junction_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-delete-replication.c b/src/fedfsc/fedfs-delete-replication.c
index aff44f6..a1aca41 100644
--- a/src/fedfsc/fedfs-delete-replication.c
+++ b/src/fedfsc/fedfs-delete-replication.c
@@ -163,7 +163,7 @@ fedfs_delete_replication_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-get-limited-nsdb-params.c b/src/fedfsc/fedfs-get-limited-nsdb-params.c
index ec66d86..7e98fb2 100644
--- a/src/fedfsc/fedfs-get-limited-nsdb-params.c
+++ b/src/fedfsc/fedfs-get-limited-nsdb-params.c
@@ -190,7 +190,7 @@ fedfs_get_limited_nsdb_params_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-get-nsdb-params.c b/src/fedfsc/fedfs-get-nsdb-params.c
index 4bef1aa..3bd1e98 100644
--- a/src/fedfsc/fedfs-get-nsdb-params.c
+++ b/src/fedfsc/fedfs-get-nsdb-params.c
@@ -206,7 +206,7 @@ fedfs_get_nsdb_params_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-lookup-junction.c b/src/fedfsc/fedfs-lookup-junction.c
index b43a6ae..d9fb519 100644
--- a/src/fedfsc/fedfs-lookup-junction.c
+++ b/src/fedfsc/fedfs-lookup-junction.c
@@ -242,7 +242,7 @@ fedfs_lookup_junction_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-lookup-replication.c b/src/fedfsc/fedfs-lookup-replication.c
index e258f8b..c6f0b2c 100644
--- a/src/fedfsc/fedfs-lookup-replication.c
+++ b/src/fedfsc/fedfs-lookup-replication.c
@@ -243,7 +243,7 @@ fedfs_lookup_replication_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-null.c b/src/fedfsc/fedfs-null.c
index 8e63b7d..2476eaf 100644
--- a/src/fedfsc/fedfs-null.c
+++ b/src/fedfsc/fedfs-null.c
@@ -156,7 +156,7 @@ fedfs_null_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;
diff --git a/src/fedfsc/fedfs-set-nsdb-params.c b/src/fedfsc/fedfs-set-nsdb-params.c
index 2ac3568..70473fd 100644
--- a/src/fedfsc/fedfs-set-nsdb-params.c
+++ b/src/fedfsc/fedfs-set-nsdb-params.c
@@ -176,7 +176,7 @@ fedfs_set_nsdb_params_host(const char *hostname, const char *nettype,
 		break;
 	default:
 		xlog(L_ERROR, "%s",
-			admin_open_perror(admin_hostname(host)));
+			admin_open_perror(hostname));
 	}
 
 	return status;